(function(){
  var ref$, filter, find, findIndex, initial, last, map, partition, reject, reverse, sortBy, clamp, isEqualToObject, React, div, input, span, cancelEvent;
  ref$ = require('prelude-ls'), filter = ref$.filter, find = ref$.find, findIndex = ref$.findIndex, initial = ref$.initial, last = ref$.last, map = ref$.map, partition = ref$.partition, reject = ref$.reject, reverse = ref$.reverse, sortBy = ref$.sortBy;
  ref$ = require('prelude-extension'), clamp = ref$.clamp, isEqualToObject = ref$.isEqualToObject;
  React = require('react'), ref$ = React.DOM, div = ref$.div, input = ref$.input, span = ref$.span;
  cancelEvent = function(e){
    e.preventDefault();
    e.stopPropagation();
  };
  module.exports = React.createClass({
    displayName: 'ReactSelectize',
    highlightedOption: -1,
    focusLock: false,
    scrollLock: false,
    getDefaultProps: function(){
      return {
        anchor: null,
        className: '',
        disabled: false,
        firstOptionIndexToHighlight: function(options){
          return 0;
        },
        onAnchorChange: function(anchor){},
        onBlur: function(values, reason){},
        onFocus: function(values, reason){},
        onOpenChange: function(open, callback){},
        onSearchChange: function(search, callback){},
        onValuesChange: function(values, callback){},
        open: false,
        options: [],
        renderNoResultsFound: function(){
          return div({
            className: 'no-results-found'
          }, "No results found");
        },
        renderOption: function(index, arg$){
          var label, newOption, selectable, isSelectable;
          if (arg$ != null) {
            label = arg$.label, newOption = arg$.newOption, selectable = arg$.selectable;
          }
          isSelectable = typeof selectable === 'undefined' || selectable;
          return div({
            className: "simple-option " + (isSelectable ? '' : 'not-selectable'),
            key: index
          }, span(null, !!newOption ? "Add " + label + " ..." : label));
        },
        renderValue: function(index, arg$){
          var label;
          label = arg$.label;
          return div({
            className: 'simple-value',
            key: index
          }, span(null, label));
        },
        search: "",
        style: {},
        values: []
      };
    },
    render: function(){
      var anchorIndex, this$ = this;
      anchorIndex = (function(){
        var ref$;
        switch (false) {
        case !(typeof this.props.anchor === 'undefined' || this.props.anchor === null):
          return -1;
        default:
          return (ref$ = findIndex(function(it){
            return isEqualToObject(it, this$.props.anchor);
          }, this.props.values)) != null
            ? ref$
            : this.props.values.length - 1;
        }
      }.call(this));
      return div({
        className: "react-selectize " + this.props.className + " " + (this.props.disabled ? 'disabled' : '') + " " + (this.props.open ? 'open' : ''),
        style: this.props.style,
        onClick: function(){
          return this$.props.onAnchorChange(last(this$.props.values), function(){
            return this$.props.onOpenChange(true, function(){
              return this$.focus();
            });
          });
        }
      }, div({
        className: 'control',
        key: 'control'
      }, this.props.search.length === 0 && this.props.values.length === 0 ? div({
        className: 'placeholder'
      }, this.props.placeholder) : void 8, map(function(index){
        return this$.props.renderValue(index, this$.props.values[index]);
      })(
      (function(){
        var i$, to$, results$ = [];
        for (i$ = 0, to$ = anchorIndex; i$ <= to$; ++i$) {
          results$.push(i$);
        }
        return results$;
      }())), input({
        disabled: this.props.disabled,
        ref: 'search',
        type: 'text',
        value: this.props.search,
        onChange: function(arg$){
          var value;
          value = arg$.currentTarget.value;
          return this$.props.onSearchChange(value, function(){
            if (!this$.highlightAndScrollToSelectableOption(this$.props.firstOptionIndexToHighlight(this$.props.options), 1)) {
              return this$.lowlightOption();
            }
          });
        },
        onFocus: function(){
          (function(){
            return function(callback){
              if (!!this$.focusLock) {
                return callback(this$.focusLock = false);
              } else {
                return this$.props.onOpenChange(true, function(){
                  return callback(true);
                });
              }
            };
          })()(function(result){
            return this$.props.onFocus(this$.props.values, !!result ? 'event' : 'focus');
          });
        },
        onKeyDown: function(e){
          switch (e.which) {
          case 9:
            this$.props.onOpenChange(false, function(){
              return this$.props.onAnchorChange(last(this$.props.values), function(){
                return this$.props.onBlur(this$.props.values, 'tab');
              });
            });
            break;
          case 8:
            if (this$.props.search.length > 0 || anchorIndex === -1) {
              return;
            }
            (function(){
              var anchorIndexOnRemove, nextAnchor, valueToRemove, ref$;
              anchorIndexOnRemove = anchorIndex;
              nextAnchor = anchorIndex - 1 < 0
                ? undefined
                : this$.props.values[anchorIndex - 1];
              valueToRemove = this$.props.values[anchorIndex];
              return this$.props.onValuesChange((ref$ = reject(function(it){
                return isEqualToObject(it, valueToRemove);
              }, this$.props.values)) != null
                ? ref$
                : [], function(){
                return function(){
                  return function(callback){
                    if (typeof find(function(it){
                      return isEqualToObject(it, valueToRemove);
                    }, this$.props.values === 'undefined')) {
                      if (!!this$.props.restoreOnBackspace) {
                        return this$.props.onSearchChange(this$.props.restoreOnBackspace(valueToRemove), function(){
                          return callback(true);
                        });
                      } else {
                        return callback(true);
                      }
                    } else {
                      return callback(false);
                    }
                  };
                }()(function(result){
                  if (!!result) {
                    this$.highlightAndScrollToSelectableOption(this$.props.firstOptionIndexToHighlight(this$.props.options), 1);
                  }
                  if (!!result && anchorIndex === anchorIndexOnRemove && (typeof nextAnchor === 'undefined' || !!find(function(it){
                    return isEqualToObject(it, nextAnchor);
                  }, this$.props.values))) {
                    return this$.props.onAnchorChange(nextAnchor, function(){});
                  }
                });
              });
            })();
            cancelEvent(e);
            break;
          case 27:
            (function(){
              if (this$.props.open) {
                return function(it){
                  return this$.props.onOpenChange(false, it);
                };
              } else {
                return function(it){
                  return this$.props.onValuesChange([], it);
                };
              }
            })()(function(){
              return this$.props.onSearchChange("", function(){
                return this$.focus();
              });
            });
          }
          if (this$.props.search.length === 0) {
            switch (e.which) {
            case 37:
              this$.props.onAnchorChange(anchorIndex - 1 < 0 || e.metaKey
                ? undefined
                : this$.props.values[clamp(anchorIndex - 1, 0, this$.props.values.length - 1)], function(){});
              break;
            case 39:
              this$.props.onAnchorChange(e.metaKey
                ? last(this$.props.values)
                : this$.props.values[clamp(anchorIndex + 1, 0, this$.props.values.length - 1)], function(){});
            }
          }
          if (this$.props.options.length === 0) {
            return;
          }
          if (e.which === 13 && this$.props.open) {
            this$.selectHighlightedOption(anchorIndex, function(){
              if (this$.props.open && !this$.highlightAndScrollToSelectableOption(this$.highlightedOption, 1)) {
                if (!this$.highlightAndScrollToSelectableOption(0, 1)) {
                  return this$.lowlightOption();
                }
              }
            });
          } else {
            switch (e.which) {
            case 38:
              this$.scrollLock = true;
              this$.highlightAndScrollToSelectableOption(this$.highlightedOption - 1, -1);
              break;
            case 40:
              this$.scrollLock = true;
              this$.highlightAndScrollToSelectableOption(this$.highlightedOption + 1, 1);
              break;
            default:
              return;
            }
          }
          return cancelEvent(e);
        }
      }), map(function(index){
        return this$.props.renderValue(index, this$.props.values[index]);
      })(
      (function(){
        var i$, to$, results$ = [];
        for (i$ = anchorIndex + 1, to$ = this.props.values.length; i$ < to$; ++i$) {
          results$.push(i$);
        }
        return results$;
      }.call(this))), div({
        className: 'reset',
        onClick: function(e){
          (function(){
            return this$.props.onValuesChange([], function(){
              return this$.props.onSearchChange("", function(){
                return this$.focus();
              });
            });
          })();
          return cancelEvent(e);
        }
      }, '×'), div({
        className: 'arrow'
      }, null)), this.props.open ? div({
        className: 'options'
      }, this.props.options.length === 0
        ? this.props.renderNoResultsFound()
        : map(function(index){
          var option;
          option = this$.props.options[index];
          return div(import$({
            className: 'option-wrapper',
            ref: "option-" + index,
            key: index + "",
            onMouseMove: function(arg$){
              var currentTarget;
              currentTarget = arg$.currentTarget;
              if (this$.scrollLock) {
                this$.scrollLock = false;
              }
            },
            onMouseOut: function(){
              if (!this$.scrollLock) {
                this$.lowlightOption();
              }
            }
          }, (function(){
            switch (false) {
            case !(typeof (option != null ? option.selectable : void 8) === 'boolean' && !option.selectable):
              return {
                onClick: cancelEvent
              };
            default:
              return {
                onClick: function(e){
                  this$.selectHighlightedOption(anchorIndex, function(){});
                },
                onMouseOver: function(arg$){
                  var currentTarget;
                  currentTarget = arg$.currentTarget;
                  if (!this$.scrollLock) {
                    this$.highlightOption(index);
                  }
                }
              };
            }
          }())), this$.props.renderOption(index, option));
        })(
        (function(){
          var i$, to$, results$ = [];
          for (i$ = 0, to$ = this.props.options.length; i$ < to$; ++i$) {
            results$.push(i$);
          }
          return results$;
        }.call(this)))) : void 8);
    },
    componentDidMount: function(){
      var this$ = this;
      this.externalClickListener = function(arg$){
        var target, domNodeContains;
        target = arg$.target;
        domNodeContains = function(element){
          if (typeof element === 'undefined' || element === null) {
            return false;
          }
          if (element === this$.getDOMNode()) {
            return true;
          }
          return domNodeContains(element.parentElement);
        };
        if (!domNodeContains(target)) {
          this$.props.onOpenChange(false);
          return this$.props.onBlur(this$.props.values, 'click');
        }
      };
      document.addEventListener('click', this.externalClickListener, true);
    },
    componentWillUnmount: function(){
      document.removeEventListener('click', this.externalClickListener, true);
    },
    componentDidUpdate: function(prevProps, prevState){
      var x$, $search;
      if (this.props.open && !prevProps.open && (this.highlightedOption = -1)) {
        this.highlightAndScrollToSelectableOption(this.props.firstOptionIndexToHighlight(this.props.options), 1);
        this.focus();
      }
      if (!this.props.open && prevProps.open) {
        this.highlightedOption = -1;
      }
      x$ = $search = this.refs.search.getDOMNode();
      x$.style.width = 0;
      x$.style.width = $search.scrollWidth;
      return x$;
    },
    componentWillReceiveProps: function(props){
      if ((typeof this.props.disabled === 'undefined' || this.props.disabled === false) && (typeof props.disabled !== 'undefined' && props.disabled === true)) {
        this.props.onOpenChange(false);
      }
    },
    focus: function(){
      if (this.refs.search.getDOMNode() !== document.activeElement) {
        this.focusLock = true;
        this.refs.search.getDOMNode().focus();
      }
    },
    blur: function(){
      this.refs.search.getDOMNode().blur();
      this.props.onBlur(this.props.values, 'blur');
    },
    highlightOption: function(index){
      var x$, optionElement, ref$, ref1$;
      this.lowlightOption();
      this.highlightedOption = index;
      x$ = optionElement = (ref$ = this.refs) != null ? (ref1$ = ref$["option-" + index]) != null ? ref1$.getDOMNode() : void 8 : void 8;
      if (x$ != null) {
        x$.className = "option-wrapper focused";
      }
      return optionElement;
    },
    lowlightOption: function(){
      var ref$, ref1$, ref2$;
      if ((ref$ = this.refs) != null) {
        if ((ref1$ = ref$["option-" + this.highlightedOption]) != null) {
          if ((ref2$ = ref1$.getDOMNode()) != null) {
            ref2$.className = 'option-wrapper';
          }
        }
      }
      this.highlightedOption = -1;
    },
    highlightAndScrollToOption: function(index){
      var optionElement, parentElement, optionHeight;
      if ((optionElement = this.highlightOption(index)) != null) {
        parentElement = optionElement.parentElement;
      }
      if (!!optionElement) {
        optionHeight = optionElement.offsetHeight - 1;
        if (optionElement.offsetTop - parentElement.scrollTop >= parentElement.offsetHeight) {
          parentElement.scrollTop = optionElement.offsetTop - parentElement.offsetHeight + optionHeight;
        } else if (optionElement.offsetTop - parentElement.scrollTop + optionHeight <= 0) {
          parentElement.scrollTop = optionElement.offsetTop;
        }
      }
    },
    highlightAndScrollToSelectableOption: function(index, direction){
      var this$ = this;
      return function(){
        if (!this$.props.open) {
          return function(it){
            return this$.props.onOpenChange(true, it);
          };
        } else {
          return function(it){
            return it();
          };
        }
      }()(function(){
        var option, ref$, ref1$;
        if (index < 0 || index >= this$.props.options.length) {
          return false;
        } else {
          option = (ref$ = this$.props) != null ? (ref1$ = ref$.options) != null ? ref1$[index] : void 8 : void 8;
          if (typeof (option != null ? option.selectable : void 8) === 'boolean' && !option.selectable) {
            return this$.highlightAndScrollToSelectableOption(index + direction, direction);
          } else {
            this$.highlightAndScrollToOption(index);
            return true;
          }
        }
      });
    },
    selectHighlightedOption: function(anchorIndex, callback){
      var option, ref$, this$ = this;
      if (this.highlightedOption !== -1) {
        option = (ref$ = this.props.options) != null ? ref$[this.highlightedOption] : void 8;
        this.props.onValuesChange(map(function(it){
          return this$.props.values[it];
        }, (function(){
          var i$, to$, results$ = [];
          for (i$ = 0, to$ = anchorIndex; i$ <= to$; ++i$) {
            results$.push(i$);
          }
          return results$;
        }())).concat([option], map(function(it){
          return this$.props.values[it];
        }, (function(){
          var i$, to$, results$ = [];
          for (i$ = anchorIndex + 1, to$ = this.props.values.length; i$ < to$; ++i$) {
            results$.push(i$);
          }
          return results$;
        }.call(this)))), function(){
          var value;
          value = find(function(it){
            return isEqualToObject(it, option);
          }, this$.props.values);
          if (!!value) {
            return this$.props.onSearchChange("", function(){
              return this$.props.onAnchorChange(value, callback);
            });
          } else {
            return callback();
          }
        });
      }
    }
  });
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
